000001 IDENTIFICATION DIVISION.
000002 PROGRAM-ID.  SCRDEMO.
000003*    This program demonstrates the Screen Module, and
000004*    shows the control fields returned after various
000005*    operations. The user may change the control fields
000006*    on each return to the Screen module and view the
000007*    result.
000008 ENVIRONMENT DIVISION.
000009 CONFIGURATION SECTION.
000010 SPECIAL-NAMES.
000011     DATE IS "E-".
000012*    A- American, E- European.
000013 INPUT-OUTPUT SECTION.
000014 FILE-CONTROL.
000015 DATA DIVISION.
000016 WORKING-STORAGE SECTION.
000017 01  RETURNED-FIELDS.
000018     05  RETURNED-POINTER     PIC 9999 COMP.
000019     05  RETURNED-COLUMN      PIC 9999 COMP.
000020 77  SCREEN-COMMENT           PIC X(32) VALUE SPACES.
000021 01  SCREEN-DATA.
000022     05  NORMAL-DATA          PIC X(10) VALUE "Reference".
000023     05  UPPER-DATA           PIC X(10) VALUE "CAPITALS".
000024     05  RETURN-FIELD         PIC X(10) VALUE "General".
000025     05  NUMERIC-FIELD        PIC S9999V99 VALUE 34.8.
000026     05  BLANK-FIELD          PIC 99V999 PACKED VALUE 11.
000027     05  DATE-FIELD           DATE VALUE "23-11-2003".
000028     05  TEXT-FIELD.
000029*                 ....v....1....v....2....v....3....v
000030       10  VALUE "This is a sample of text data which ".
000031       10  VALUE "is word-wrapped in the assigned ".
000032       10  VALUE "screen allocated to it.     ".
000033     05  CAPITALISED-FIELD    PIC X(24)
000034           VALUE "23a west albion street".
000035     05  PHONE-NUMBER.
000036       10  PHONE-CITY         PIC 99   VALUE 04.
000037       10  PHONE-XCHG         PIC 999  VALUE 733.
000038       10  PHONE-ITEM         PIC 9999 VALUE 3816.
000039 01  FORMAT-DATA.
000040     05  MAIN-SCREEN.
000041       10  VALUE "|VScreen IO Demonstration".
000042       10  VALUE "|ANL|C0502Field|Nnumber:".
000043       10  VALUE "|C0902 1|C0907|F0210|C0919Normal data".
000044       10  VALUE "|C1202 2|C1207|F0210|C1219RETURN data".
000045       10  VALUE "|C1502 3|C1507|F0210|C1519UPPER data".
000046       10  VALUE "|C1802 4|C1807|F0208|C1819Numeric".
000047       10  VALUE "|C2102 5|C2107|F0206|C2119".
000048       10  VALUE "BLANK WHEN ZERO".
000049       10  VALUE "|C2402 6|C2407|F0210".
000050       10  VALUE "|C2419Type E date dd-mm-ccyy".
000051       10  VALUE "|C2702 7-9|C2707|F0211".
000052       10  VALUE "|ANW|C2709-   -|ANL".
000053       10  VALUE "|C2719AUTO-TERM fields".
000054       10  VALUE "|C3028Text field".
000055       10  VALUE "|C320210|C3207|F0632|C3240".
000056       10  VALUE "|C390211|C3907|F0224".
000057       10  VALUE "|C420212|C4207|B0408C_onvert|NInitials".
000058       10  VALUE "|C4217Click here to capitalise".
000059       10  VALUE "|Nthe initials in Field 11".
000060       10  VALUE "|C470213|C4707|B0212 No Alt-key".
000061       10  VALUE "|C500214|C5007".
000062       10  VALUE "|B0212Alt-A_ button".
000063       10  VALUE "|C530215|C5307|B0412".
000064       10  VALUE "  Two line|NAlt-T_ button".
000065       10  VALUE "|X".
000066     05  SCREEN-DESCRIPTION.
000067       10  VALUE "|Z|ANC|TC|C0943|L4536|N".
000068       10  VALUE "|N Make any changes to these fields ".
000069       10  VALUE "|N or click on any field or button ".
000070       10  VALUE "|N in order to demonstrate how the ".
000071       10  VALUE "|N Screen Module responds in the ".
000072       10  VALUE "|N standard fields.|N|N".
000073       10  VALUE "|N When you perform an action that".
000074       10  VALUE "|N causes a return to the program,".
000075       10  VALUE "|N the values which are returned ".
000076       10  VALUE "|N to the program are shown here.|N|N".
000077       10  VALUE "|N You may alter SCREEN-POINTER,".
000078       10  VALUE "|N SCREEN-COLUMN and SCREEN-COMMENT,".
000079       10  VALUE "|N and re-enter the Screen Module,".
000080       10  VALUE "|N or you may exit the program.".
000081       10  VALUE "|ANL|TD".
000082       10  VALUE "|X".
000083     05  RETURN-SCREEN-FORMAT.
000084       10  VALUE "|Z|C0943|W4536".
000085       10  VALUE " Return from ACCEPT SCREEN".
000086       10  VALUE "|C1145SCREEN-STATUS:".
000087       10  VALUE "|C1345|F0201|C1347|F0230".
000088       10  VALUE "|C1645SCREEN-FIELD:".
000089       10  VALUE "|C1845|F0204|C1850|F0227".
000090       10  VALUE "|C2143|P2836".
000091       10  VALUE "|TC|C2245You may alter the following".
000092       10  VALUE "|Nthree fields before your".
000093       10  VALUE "|Nnext re-entry".
000094       10  VALUE "|C3350First field on next entry".
000095       10  VALUE "|C4050First column on next entry".
000096       10  VALUE "|TD".
000097       10  VALUE "|C2945SCREEN-POINTER:".
000098       10  VALUE "|C3145|F0204|C3150|F0227".
000099       10  VALUE "|C3645SCREEN-COLUMN:".
000100       10  VALUE "|C3845|F0204|C3850|F0227".
000101       10  VALUE "|C4345SCREEN-COMMENT:".
000102       10  VALUE "|C4545|F0232".
000103       10  VALUE "|C5150|B0208Re-E_nter".
000104       10  VALUE "|C5165|B0208  eX_it".
000105       10  VALUE "|ABW|C1347".
000106       10  STATUS-DESCRIPTION  PIC X(30) VALUE SPACES.
000107       10  VALUE "|C1850".
000108       10  FIELD-DESCRIPTION   PIC X(27) VALUE SPACES.
000109       10  VALUE "|C3150".
000110       10  POINTER-DESCRIPTION PIC X(27) VALUE SPACES.
000111       10  VALUE "|C3850".
000112       10  COLUMN-DESCRIPTION  PIC X(27) VALUE SPACES.
000113       10  VALUE "|ANW".
000114       10  VALUE "|X".
000115       10  VALUE "|X".
000116
000117 SCREEN SECTION.
000118 SCREEN-FIELDS GROUP.
000119     NORMAL-DATA              AT 0907.
000120     RETURN-FIELD             AT 1207 RETURN.
000121     UPPER-DATA               AT 1507 UPPER.
000122     NUMERIC-FIELD            AT 1807.
000123     BLANK-FIELD              AT 2107 BLANK ZERO.
000124     DATE-FIELD               AT 2407.
000125     PHONE-CITY               AT 2707 AUTO-TERM.
000126     PHONE-XCHG               AT 2710 AUTO-TERM.
000127     PHONE-ITEM               AT 2714.
000128     TEXT-FIELD               AT 3207 FOR 0632.
000129     CAPITALISED-FIELD        AT 3907.
000130     BUTTON AT 4207 FOR 0208.      * 12: Capitalise
000131     BUTTON AT 4707 FOR 0212.      * 13: No Alt-key
000132     BUTTON AT 5007 FOR 0212 "A".  * 14: Alt-A
000133     BUTTON AT 5307 FOR 0412 "T".  * 15: Two-line Alt-T
000134     BUTTON AT 0278 FOR 0202 "X".  * 16: Exit button
000135 RETURN-FIELDS GROUP.
000136     SCREEN-STATUS            AT 1345 DISPLAY.
000137     SCREEN-FIELD             AT 1845 DISPLAY.
000138     RETURNED-POINTER         AT 3145.
000139     RETURNED-COLUMN          AT 3845.
000140     SCREEN-COMMENT           AT 4545.
000141     BUTTON AT 5150 FOR 0208.  * 6: Re-enter
000142     BUTTON AT 5165 FOR 0208.  * 7: Exit
000143     BUTTON AT 0476 FOR 0202.  * 8: Exit
000144
000145 PROCEDURE DIVISION.
000146 MAIN-ROUTINE SECTION.
000147 MAIN-ENTRY.
000148     DISPLAY FORMAT MAIN-SCREEN SCREEN-DESCRIPTION
000149     DISPLAY SCREEN
000150     PERFORM UNTIL EXIT
000151       ACCEPT SCREEN
000152       IF SCREEN-STATUS = "L"
000153         AND SCREEN-POINTER = 12
000154         INSPECT CAPITALISED-FIELD CONVERTING INITIALS
000155         MOVE 11 TO SCREEN-POINTER
000156       ELSE
000157         MOVE "The current field" TO FIELD-DESCRIPTION
000158         MOVE "The next field in sequence"
000159           TO POINTER-DESCRIPTION
000160         MOVE "The current field column"
000161           TO COLUMN-DESCRIPTION
000162         EVALUATE SCREEN-STATUS
000163           WHEN "F"
000164             MOVE "RETURN field exited"
000165               TO STATUS-DESCRIPTION
000166             MOVE "The RETURN field" TO FIELD-DESCRIPTION
000167             MOVE "The next field column"
000168               TO COLUMN-DESCRIPTION
000169           WHEN "E"
000170             MOVE "Enter key pressed"
000171               TO STATUS-DESCRIPTION
000172           WHEN "X"
000173             MOVE "Esc key pressed" TO STATUS-DESCRIPTION
000174             MOVE "The current field"
000175               TO POINTER-DESCRIPTION
000176           WHEN "D"
000177             MOVE "PgDn key pressed" TO STATUS-DESCRIPTION
000178           WHEN "U"
000179             MOVE "PgUp key pressed" TO STATUS-DESCRIPTION
000180           WHEN "K"
000181             MOVE "Function key pressed"
000182               TO STATUS-DESCRIPTION
000183             MOVE "The Function key number"
000184               TO POINTER-DESCRIPTION
000185           WHEN "L"
000186             MOVE "Left click or Alt-x on button"
000187               TO STATUS-DESCRIPTION
000188             MOVE "Clicked or Alt-x button"
000189               TO POINTER-DESCRIPTION
000190           WHEN "R"
000191             MOVE "Right clicked field or button"
000192               TO STATUS-DESCRIPTION
000193             MOVE "Clicked field or button"
000194               TO POINTER-DESCRIPTION
000195             MOVE "The column clicked on"
000196               TO COLUMN-DESCRIPTION
000197         END-EVALUATE
000198         MOVE SCREEN-POINTER TO RETURNED-POINTER
000199         MOVE SCREEN-COLUMN TO RETURNED-COLUMN
000200         MOVE SPACES TO SCREEN-COMMENT
000201         DISPLAY FORMAT RETURN-SCREEN-FORMAT
000202         SET SCREEN TO RETURN-FIELDS
000203         MOVE 1 TO SCREEN-POINTER
000204         DISPLAY SCREEN
000205         ACCEPT SCREEN
000206         IF SCREEN-POINTER = 7 OR 8
000207         OR SCREEN-STATUS = "X"
000208           EXIT PERFORM
000209         END-IF
000210         DISPLAY FORMAT SCREEN-DESCRIPTION
000211         SET SCREEN TO SCREEN-FIELDS
000212         MOVE RETURNED-POINTER TO SCREEN-POINTER
000213         MOVE RETURNED-COLUMN TO SCREEN-COLUMN
000214         IF SCREEN-COMMENT NOT = SPACES
000215           SET SCREEN COMMENT TO SCREEN-COMMENT
000216         END-IF
000217       END-IF
000218     END-PERFORM
000219     STOP RUN.
